#ifdef _WIN32

#ifndef SJIS
#define SJIS
#endif	/* SJIS */

#include <dirent.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

/* Extensions for VC Library */

int scandir(const char *dirp, struct dirent ***namelist,
	int (*filter)(const struct dirent *),
	int (*compar)(const struct dirent **, const struct dirent **))
{
	DIR *Directory;
	int NumOfEntries, NumOfNames, i;
	struct dirent **Names;
	struct dirent *Entry;
	struct dirent *Name;
	size_t namelen;

	if(!namelist) return -1;

	Directory = opendir(dirp);
	if (!Directory) return -1;

	for (NumOfEntries = 0; readdir(Directory); NumOfEntries++);
	rewinddir(Directory);

	Names = (struct dirent **)malloc(sizeof(struct direntry *) * NumOfEntries);
	if (!Names) {
		closedir(Directory);
		return -1;}

	for (NumOfNames = 0, i = 0; i < NumOfEntries ; i++) {
		Entry = readdir(Directory);
		if (filter && filter(Entry) == 0) continue;

		namelen = (Entry->d_namlen)?Entry->d_namlen:strnlen(Entry->d_name, FILENAME_MAX - 1);

		Name = (struct dirent *)malloc(((size_t)&((struct dirent *)0)->d_name) + namelen + 1);
		if (!Name) {
			while (NumOfNames) free(Names[--NumOfNames]);
			free(Names);
			closedir(Directory);
			return -1;}

		Name->d_ino = Entry->d_ino;
		Name->d_reclen = Entry->d_reclen;
		Name->d_namlen = namelen;
		memcpy(Name->d_name, Entry->d_name, namelen);
		Name->d_name[namelen] = '\0';

		Names[NumOfNames++] = Name;}

	closedir(Directory);

	if (!NumOfNames) {
		free(Names);
		return 0;}

	if (compar) {
		qsort(Names, NumOfNames, sizeof(struct dirent *),
			(int (*)(const void *, const void *))compar);}

	*namelist = (struct dirent **)realloc(Names, sizeof(struct direntry *) * NumOfNames);
	if (!*namelist) *namelist = Names;

	return NumOfNames;
}

int alphasort(const struct dirent **a, const struct dirent **b)
{
	return (strcoll((*a)->d_name, (*b)->d_name));
}

#endif	/* _WIN32 */
