#ifdef _WIN32

#ifndef SJIS
#define SJIS
#endif	/* SJIS */

#include <ctype.h>
#include <string.h>
#include <malloc.h>
#include <winnls.h>

/* Extensions for VC Library */

char *strcasestr(const char *haystack, const char *needle)
{
	size_t len;

	if (!haystack || !needle) return NULL;

	len = strlen(needle);

	while (*haystack) {
		if (strnicmp(haystack, needle, len) == 0) return (char *)haystack;
		haystack++;}

	return NULL;
}

char *strsep(char **stringp, const char *delim)
{
	char *token = *stringp;
	char *next_delim;

	if (!token) return NULL;

	next_delim = strpbrk(token, delim);
	if (next_delim) {
		*next_delim = '\0';
		*stringp = next_delim + 1;}
	else {
		*stringp = NULL;}

	return token;
}

/* Supports for Shift_JIS encoding */

int ConvertSJIStoUTF8(char *Dest, int BufferLength, const char *Src)
{
	WCHAR *UnicodeString;
	int UnicodeLength;

	if (!Dest || !Src) return -1;

	UnicodeLength = MultiByteToWideChar(CP_ACP, 0, Src, -1, NULL, 0);
	if (!UnicodeLength) {
		Dest[0] = '\0';
		return -1;}

	UnicodeString = (WCHAR *)malloc(sizeof(WCHAR) * UnicodeLength);
	if (!UnicodeString) {
		Dest[0] = '\0';
		return -1;}

	if (!MultiByteToWideChar(CP_ACP, 0, Src, -1, UnicodeString, UnicodeLength)) {
		free(UnicodeString);
		Dest[0] = '\0';
		return -1;}

	if (!WideCharToMultiByte(CP_UTF8, 0, UnicodeString, UnicodeLength, Dest, BufferLength, NULL, NULL)) {
		free(UnicodeString);
		Dest[0] = '\0';
		return -1;}

	free(UnicodeString);

	return 0;
}

#endif	/* _WIN32 */
